@echo off

rem	install protop
rem
rem	if %1 = "silent" blank do a silent install
rem


rem	can we find Progress?
rem

if not defined DLC (

	if exist wstub\pt3insterr.vbs (
		wscript wstub\pt3insterr.vbs
	) else (
		echo Cannot find Progress, aborting install
		pause
	)
	goto end
)


rem	are we running with permission to perform the install?
rem

net session > NUL 2>&1

if not errorlevel 0 (
        echo Current permissions are inadequate.  You must run pt3inst as administrator.
	goto end
)


if exist %PROTOP%\preinst.bat (
	call %PROTOP%\preinst.bat
	del /q %PROTOP%\preinst.bat 2>NUL
)

rem	if there a wstub\portalenv.bat was shipped, use it first
rem

if exist wstub\portalenv.bat (
        call wstub\portalenv.bat
)

rem	override wstub if the bin version exists
rem

if exist bin\portalenv.bat (
        call bin\portalenv.bat
)

rem	use pt3inst.pf is it exists
rem

if exist pt3inst.pf (
        set PFFILE=-pf pt3inst.pf
    ) else (
	    set PFFILE=
)

rem	the installer always runs either x-code or r-code so -rx should always be used

set RX=-rx

mode con cols=160 lines=48

set LOGFILE=pt3inst.log

if exist .\lib\install.p (

	ubin\date "+%%y/%%m/%%d %%T " >> %LOGFILE%

	if "%1"=="silent" (
		%DLC%\bin\_progres -1 -b -p .\lib\install.p %RX% -clientlog pt3inst.debug %PFFILE% >> pt3inst.err 2>&1
	) else (
		%DLC%\bin\_progres -1 -p .\lib\install.p %RX% -clientlog pt3inst.debug %PFFILE%
	)

	copy /y bin\protopenv.bat %WRKDIR% > NUL 2>&1

	ubin\date "+%%y/%%m/%%d %%T " >> %LOGFILE%

	if exist %PROTOP%\postinst.bat (
		call %PROTOP%\postinst.bat
		del /q %PROTOP%\postinst.bat 2>NUL
	)
                                        

) else (
	echo "You must be in the ProTop 3 install directory to run pt3inst.bat"
)

:end

rem	all done
rem
